// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// HashicorpCloudPacker20230101BucketAncestry The parent-child relationship between two buckets.
//
// swagger:model hashicorp.cloud.packer_20230101.BucketAncestry
type HashicorpCloudPacker20230101BucketAncestry struct {

	// The child bucket and the version in that bucket that relates tom the parent.
	Child *HashicorpCloudPacker20230101Child `json:"child,omitempty"`

	// The parent bucket and version that relates to the child bucket's
	// latest version.
	Parent *HashicorpCloudPacker20230101Parent `json:"parent,omitempty"`

	// The status of the relationship between the parent and child buckets.
	Status *HashicorpCloudPacker20230101AncestryStatus `json:"status,omitempty"`
}

// Validate validates this hashicorp cloud packer 20230101 bucket ancestry
func (m *HashicorpCloudPacker20230101BucketAncestry) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateChild(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParent(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) validateChild(formats strfmt.Registry) error {
	if swag.IsZero(m.Child) { // not required
		return nil
	}

	if m.Child != nil {
		if err := m.Child.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("child")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("child")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) validateParent(formats strfmt.Registry) error {
	if swag.IsZero(m.Parent) { // not required
		return nil
	}

	if m.Parent != nil {
		if err := m.Parent.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("parent")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) validateStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.Status) { // not required
		return nil
	}

	if m.Status != nil {
		if err := m.Status.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this hashicorp cloud packer 20230101 bucket ancestry based on the context it is used
func (m *HashicorpCloudPacker20230101BucketAncestry) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateChild(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParent(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) contextValidateChild(ctx context.Context, formats strfmt.Registry) error {

	if m.Child != nil {

		if swag.IsZero(m.Child) { // not required
			return nil
		}

		if err := m.Child.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("child")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("child")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) contextValidateParent(ctx context.Context, formats strfmt.Registry) error {

	if m.Parent != nil {

		if swag.IsZero(m.Parent) { // not required
			return nil
		}

		if err := m.Parent.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("parent")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudPacker20230101BucketAncestry) contextValidateStatus(ctx context.Context, formats strfmt.Registry) error {

	if m.Status != nil {

		if swag.IsZero(m.Status) { // not required
			return nil
		}

		if err := m.Status.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HashicorpCloudPacker20230101BucketAncestry) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HashicorpCloudPacker20230101BucketAncestry) UnmarshalBinary(b []byte) error {
	var res HashicorpCloudPacker20230101BucketAncestry
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
